# Re-usable job rules template. Does not require AutoDevOps.

# These rules are useful if you can't immediately see what a long list of job rule conditions means. There is no
# requirement to use the rules in this file.

# Disable the job if the source was not a merge request or push event. If there are open merge requests, jobs will
# run on *both* push and merge request events. Workflow rules should be used to disable one pipeline.
#
# This rule only ever *disables* a job; additional rules to enable the job must appear *after* this one.
.rules:disable-except-for-pushes-and-merge-requests:
  - if: '($CI_PIPELINE_SOURCE != "merge_request_event") && ($CI_PIPELINE_SOURCE != "push")'
    when: never

# Enable the job on merge requests or push events. If a merge request is open for the commit associated with the
# pipeline, jobs will run on *both* push and merge request pipelines. Workflow rules should be used to disable one
# pipeline.
#
# This rule only ever *enables* a job; if needed, additional rules to disable the job appear *before* this one.
.rules:enable-for-pushes-and-merge-requests:
  - if: '($CI_PIPELINE_SOURCE == "merge_request_event") || ($CI_PIPELINE_SOURCE == "push")'

# Disable the job if the source was not a push event. This job will run only on push pipelines, never on merge request
# ones.
#
# This rule only ever *disables* a job; additional rules to enable the job must appear *after* this one.
.rules:disable-except-for-pushes:
  - if: '$CI_PIPELINE_SOURCE != "push"'
    when: never

# Enable the job on *all* push events. This rule does nothing to enable a job on merge request events and enables jobs
# for push events even if there is an open merge request.
#
# This rule only ever *enables* a job; if needed, additional rules to disable the job appear *before* this one.
.rules:enable-for-pushes:
  - if: '$CI_PIPELINE_SOURCE == "push"'

# Disable the job for unless there is a tag associated with the commit. This rule does not check the pipeline event
# source.
#
# This rule only ever *disables* a job; additional rules to enable the job must appear *after* this one.
.rules:disable-for-untagged-commits:
  - if: '($CI_COMMIT_TAG == null) || ($CI_COMMIT_TAG == "")'
    when: never

# Enable the if is a tag associated with the commit. This rule does not check the pipeline event source.
#
# This rule only ever *enables* a job; if needed, additional rules to disable the job appear *before* this one.
.rules:enable-for-tagged-commits:
  - if: $CI_COMMIT_TAG
